#include "raveland.h"

int _tick;
int _timer;
int _counter;
const int _numelements = 25;
const int _arrsize = _numelements * 2 + 2;
Any _veh[_arrsize];

void Color(int count, Any veh)
{
	Vector3 _pos;
	_pos = ENTITY::GET_ENTITY_COORDS(veh, true);

	switch (count)
	{
		case 0:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 0, 0);
			break;
		case 1:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 127, 0);
			break;
		case 2:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 191, 0);
			break;
		case 3:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 255, 0);
			break;
		case 4:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 191, 255, 0);
			break;
		case 5:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 127, 255, 0);
			break;
		case 6:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 63, 255, 0);
			break;
		case 7:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 255, 0);
			break;
		case 8:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 255, 63);
			break;
		case 9:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 255, 127);
			break;
		case 10:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 255, 191);
			break;
		case 11:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 255, 255);
			break;
		case 12:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 191, 255);
			break;
		case 13:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 127, 255);
			break;
		case 14:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 63, 255);
			break;
		case 15:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 0, 0, 255);
			break;
		case 16:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 63, 0 , 255);
			break;
		case 17:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 127, 0, 255);
			break;
		case 18:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 191, 0, 255);
			break;
		case 19:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 0, 255);
			break;
		case 20:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 0, 191);
			break;
		case 21:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 0, 127);
			break;
		case 22:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 0, 63);
			break;
		case 23:
			VEHICLE::_SET_VEHICLE_NEON_LIGHTS_COLOUR(veh, 255, 63, 0);
			break;
	}
}

void main()
{
	_veh[0] = _numelements;
	_timer = 0;
	_counter = 0;

	while (true)
	{
		_tick = GetTickCount();

		if (_tick > _timer)
		{
			_timer = _tick + 200;
			_counter++;

			if (_counter > 23)
				_counter = 0;

			int _count = PED::GET_PED_NEARBY_VEHICLES(PLAYER::PLAYER_PED_ID(), _veh);

			if (_veh != NULL)
			{
				for (int i = 0; i < _count; i++)
				{
					int idoffset = i * 2 + 2;

					if (_veh[idoffset] != NULL && ENTITY::DOES_ENTITY_EXIST(_veh[idoffset]))
					{
						VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh[idoffset], 0, true);
						VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh[idoffset], 1, true);
						VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh[idoffset], 2, true);
						VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh[idoffset], 3, true);

						Color(_counter, _veh[idoffset]);
					}
				}
			}

			if (PED::IS_PED_IN_ANY_VEHICLE(PLAYER::GET_PLAYER_PED(PLAYER::PLAYER_ID()), false))
			{
				Player _player = PLAYER::PLAYER_ID();
				Ped _playerPed = PLAYER::GET_PLAYER_PED(_player);
				Vehicle _veh = PED::GET_VEHICLE_PED_IS_USING(_playerPed);

				VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh, 0, true);
				VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh, 1, true);
				VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh, 2, true);
				VEHICLE::_SET_VEHICLE_NEON_LIGHTS_ON(_veh, 3, true);

				Color(_counter, _veh);
			}
		}

		WAIT(50);
	}
}

void ScriptMain()
{
	main();
}